﻿Imports System.Reflection

Namespace LinqToDatatable
	Public Module LinqHelper
		<System.Runtime.CompilerServices.Extension> _
		Public Function CopyToDataTable(Of TSource)(ByVal source As IEnumerable(Of TSource)) As DataTable
			Dim type As Type = GetType(TSource)
			Dim columns() As PropertyInfo = type.GetProperties()
			Dim dataTable As New DataTable()
			For Each p As PropertyInfo In columns
				dataTable.Columns.Add(p.Name, p.PropertyType)
			Next p

			'import data
			For Each data As Object In source
				Dim row(columns.Length - 1) As Object
				For i As Integer = 0 To columns.Length - 1
					row(i) = columns(i).GetValue(data, Nothing)
				Next i
				dataTable.Rows.Add(row) 'add the rows to the table.
			Next data

			Return dataTable
		End Function
	End Module
End Namespace
