﻿Imports Spire.Xls

Namespace LinqToDatatable
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Dim countries As New List(Of Country)() From {New Country() With {.Name="Argentina", .Capital="Buenos Aires", .Continent="South America", .Area=2777815, .Population=32300003}, New Country() With {.Name="Bolivia", .Capital="La Paz", .Continent="South America", .Area=1098575, .Population=7300000}, New Country() With {.Name="Brazil", .Capital="Brasilia", .Continent="South America", .Area=8511196, .Population=150400000}, New Country() With {.Name="Canada", .Capital="Ottawa", .Continent="North America", .Area=9976147, .Population=26500000}, New Country() With {.Name="Chile", .Capital="Santiago", .Continent="South America", .Area=756943, .Population=13200000}, New Country() With {.Name="Colombia", .Capital="Bagota", .Continent="South America", .Area=1138907, .Population=33000000}, New Country() With {.Name="Cuba", .Capital="Havana", .Continent="North America", .Area=114524, .Population=10600000}, New Country() With {.Name="Ecuador", .Capital="Quito", .Continent="South America", .Area=455502, .Population=10600000}, New Country() With {.Name="El Salvador", .Capital="San Salvador", .Continent="North America", .Area=20865, .Population=5300000}, New Country() With {.Name="Guyana", .Capital="Georgetown", .Continent="South America", .Area=214969, .Population=800000}, New Country() With {.Name="Jamaica", .Capital="Kingston", .Continent="North America", .Area=11424, .Population=2500000}, New Country() With {.Name="Mexico", .Capital="Mexico City", .Continent="North America", .Area=1967180, .Population=88600000}, New Country() With {.Name="Nicaragua", .Capital="Managua", .Continent="North America", .Area=139000, .Population=3900000}, New Country() With {.Name="Paraguay", .Capital="Asuncion", .Continent="South America", .Area=406576, .Population=4660000}, New Country() With {.Name="Peru", .Capital="Lima", .Continent="South America", .Area=1285215, .Population=21600000}, New Country() With {.Name="United States of America", .Capital="Washington", .Continent="North America", .Area=9363130, .Population=249200000}, New Country() With {.Name="Uruguay", .Capital="Montevideo", .Continent="South America", .Area=176140, .Population=3002000}, New Country() With {.Name="Venezuela", .Capital="Caracas", .Continent="South America", .Area=912047, .Population=19700000}}

			Dim query = From c In countries
			            Where c.Area > 0
			            Select New With {Key .Name = c.Name, Key .Capital = c.Capital, Key .Area = c.Area, Key .Population = c.Population}

			Dim dataTable As DataTable = query.CopyToDataTable()

			Using frm As New Form()
				Dim dataGrid As New DataGrid()
				dataGrid.CaptionVisible = False
				dataGrid.ReadOnly = True
				dataGrid.DataSource = dataTable
				dataGrid.Dock = DockStyle.Fill

				Dim workbook As New Workbook()
				workbook.CreateEmptySheets(1)
				Dim worksheet As Worksheet = workbook.Worksheets(0)
				'worksheet.InsertDataTable(dataTable, true, 2, 1, -1, -1);
				worksheet.InsertDataTable(dataTable, True, 1, 1)
				'worksheet.InsertDataTable(dataTable, true, 1, 1, 10, 2);

				workbook.SaveToFile("Samples.xls")
				Process.Start(workbook.FileName)
			End Using
		End Sub
	End Class
End Namespace
